#include "z3-api/c++/z3++.h"
#include <vector>
#include <string>
#include <iostream>
#include <cmath>

int main() {
    z3::context ctx;
    z3::solver solver(ctx);

/*
int x = 2;
int y = 0;
while (x > y)
{
 y = y + 2;
 if (y%4 == 0) x = x + 1;
 else          x = x + 2;
}
assert(x < y);
*/

    z3::expr x = ctx.int_const("x_0");
    solver.add(x == 2);
    z3::expr y = ctx.int_const("y_0");
    solver.add(y == 0);


    z3::expr loop_cond = x > y;
    const z3::expr x_no_loop = x;
    const z3::expr y_no_loop = y;

    z3::expr y_new = ctx.int_const("y_1");
    solver.add(y_new == y + 2);
    y = y_new;

    z3::expr if_cond = (y % 4 == 0);
    z3::expr x_then = ctx.int_const("x_1");
    solver.add(x_then == x + 1);
    z3::expr x_else = ctx.int_const("x_2");
    solver.add(x_else == x + 2);
    z3::expr x_new = ctx.int_const("x_3");
    solver.add(x_new == z3::ite(if_cond, x_then, x_else));
    x = x_new;
    z3::expr x_after = ctx.int_const("x_4");
    z3::expr y_after = ctx.int_const("y_2");

    solver.add(x_after == z3::ite(loop_cond, x, x_no_loop));
    solver.add(y_after == z3::ite(loop_cond, y, y_no_loop));
    x = x_after;
    y = y_after;

    solver.add(!(x > y));
    // solver.add(x < y);

    z3::check_result res = solver.check();
    if (res == z3::check_result::sat)
    {
        z3::model model = solver.get_model();
        std::cout << model;
    } else
    {
        std::cout << "impossible" << std::endl;
    }

    return 0;
}
